/*	RandNumb.c -- accessory that replaces functions->random() with an alternative
*                random number generator and/or distribution
*	 1995,1996,1997 Another Option
*
============================================================================
|    DATE    | WHAT
============================================================================
   4 Sep 95  | created.
  28 Jul 96  | hacked at fixing the bitch again...
  30 Jul 96  | much better, but parm gadgets won't do 1.00; string gadget flashes
             | on entries if sprintf() format is %5ld -- %5.5ld works though!?
  12 Dec 96  | don't keep a list of possible configurations for different
             | songs/environments; save with the song. still does not close the
				 | freaking math libraries & won't let b&p tasks exit!!
   9 Jan 97  | WaitTOF() in remove code seems to do the trick (but I'm still not
	          | convinced that the library open/close is right)
  11 Jan 97  | fixed parm display by changing them to UWORDs instead of doubles
             | (library closing is right; one of the 1/f tools is wrong)
				 | changed parameter resolution to .001; added exponential dist, random
				 | walk; added option to display numbers generated
  13 Jan 97  | weibull is broken; added Cauchy in replacement. changed resolution
             | back to .01; increased maximum range to 20.0
  10 May 97  | uh, make strings for pot displays long enough to accommodate a
             | null from sprintf(), ok?
   4 Sep 97  | HOT DAMN! note that if there is not an install(), load() is NOT
	          | called when a song is loaded. and it only took TWO FUCKING YEARS.
				 | but at least it finally works. AND automagically opens the window
				 | if the window was open when the song was saved. whoa.
  14 Sep 97  | removed display gadget, and added it in a secret menu.
             | posted to Aminet. AND, the WOPEN flag won't work unless the window
				 | has been closed and reopend before saving a file apparently; yet
				 | another mystery...
*/

//#define DBUG 1
//#define FILEDUMP 1

#define ACC_NAME "Random Numbers"
/* multiplier to convert parameters for display */
#define PARM_MULT 100.0
/* maximum random distribution parameter value * multiplier for pot ranges */
#define MAXRANDPARM ((int)(20 * PARM_MULT))

/* don't let parm2 be less than this or fpow() underflows and burns */
#define WEIBULL_PARM_MIN 0.100000

#include <exec/exec.h>
#include <libraries/dos.h>
#include <intuition/intuition.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>
#include <libraries/mathlibrary.h>
#include <mieeedoub.h>
#include <pragmas/mathieeedoubbas_pragmas.h>
#include <pragmas/mathieeedoubtrans_pragmas.h>
#include <clib/alib_protos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>
#include "bars.h"
#include "bplib.h"
#include "barsmacros.h"
#include "proto/bplib_protos.h"
#include "proto/RandNumb_protos.h"
#include "RandNumbw.h"
#include "debug.h"
#include "/icons/RandNumbRender.h"
#include "/icons/RandNumbSelect.h"
#include "ToolID.h"

static UBYTE const versiontag[] = "$VER: Random_Numbers 40.11 (14.09.97)";

/* required to link with scm.lib */
void __regargs _CXBRK(void) { return; }
void __stdargs _XCEXIT(long code) { return; }
/* for scmieee.lib */
int _ProgramName;
int _OSERR = 0;

extern struct IntuitionBase *IntuitionBase;
extern struct GfxBase *GfxBase;
extern struct LayersBase *LayersBase;
extern struct DOSBase *DOSBase;
extern struct ExecBase *SysBase;
extern struct Functions *functions;
extern ULONG RangeSeed; /* seed for RangeRand() */

struct Library *MathIeeeDoubBasBase = NULL;
struct Library *MathIeeeDoubTransBase = NULL;
static ULONG OldRangeSeed = 0;                 /* what was the seed */
long (* __stdargs RandomAddress)(long) = NULL; /* what was functions->random() */

struct RandomPoop {
	struct Accessory accessory;
	UWORD baseflags;         /* what generator to use in distributions */
	UWORD distflags;         /* which distribution to use */
	long seed;               /* seed for generator */
	UWORD parm1;             /* parameters for distributions */
	UWORD parm2;
} RandomPoop;

/* number of bytes to save; struct + window coordinates */
#define DATA_SIZE (sizeof(struct RandomPoop) - sizeof(struct Accessory) + 4)

/* flags for the number generator */
#define BF_BPRANDOM  0 /* the usual functions->random() */
#define BF_RANGERAND 1
#define BF_FASTRAND  2
#define BF_LRAND     4

#define BF_WOPEN 0x4000 /* the window is open */
#define BF_SHOW  0x8000 /* display numbers generated */

/* flags for distributions */
#define DF_RANDRAND       1
#define DF_TRIANGLE       2
#define DF_LINEAR         4
#define DF_BETA           8
#define DF_WEIBULL     0x10
#define DF_POISSON     0x20
#define DF_INVLINEAR   0x40
#define DF_GAUSS       0x80
#define DF_GAMMA     0x0100
#define DF_EXPONENT  0x0200
#define DF_RANDWALK  0x0400
#define DF_CAUCHY    0x0800
#define DF_SPARE4    0x1000
#define DF_SPARE5    0x2000
#define DF_SPARE6    0x4000
#define DF_SPARE7    0x8000

/* coordinates for displaying the numbers generated */
#define NUM_X 297
#define NUM_Y  66

#define awin RandomPoop.accessory.window

/*==========================================================================
* fpow
*
*  INPUT: value, power
* RETURN: double
*
* EFFECT: exponentiation
*=========================================================================*/

static double __regargs fpow(double value, double power)

{
	double result;
	UBYTE neg;

	neg = (power < 0.0) ? 1 : 0;
	power = fabs(power);
	result = exp(log(value)*power);
	if (neg) result = 1.0/result;

	return(result);
}

/*==========================================================================
* exponential
*
*  INPUT: range, spread
* RETURN: long
*
* EFFECT: exponential curve; large spread increase probability of a small
*         result. mean is .69315/spread.
*=========================================================================*/

/* winsor p186 */
static long __inline exponential(long range, double spread)

{
	double u = functions->random(65535) / 65535.0;
	
	return( (long)((-log(u) / spread) * range) );
}

/*==========================================================================
* cauchy
*
*  INPUT: range, spread
* RETURN: long
*
* EFFECT: generates a Cauchy distribution with negative half folded to 
*         positive (Dodge p274; Winsor p184). will not exceed range.
*=========================================================================*/

static long __inline cauchy(long range, double spread)
{
//	static double hpi = 1.5707963; // pi/2
	double u;

	u = functions->random(65535)/65536.0;
	u = spread * tan(u * 1.5707963);
	if (u > (double)range) return((long)u % range);
	else return((long)u);
}

/*==========================================================================
* weibull
*
*  INPUT: range, spread, shape
* RETURN: long
*
* EFFECT: generates Weibull distribution limited to range (NO it doesn't, you
*         stupid turd!)
*=========================================================================*/

/***
static long __inline weibull(long range, double spread, double shape)

{
	double u;

	do {
		u = functions->random(65535) / 65536.0;
	} while (u == 0.0);
	u = 1.0 / (1.0 - u);
	return( (long)(range * (spread * fpow(log(u),1.0/shape)) + 0.5) );
}
***/

/*==========================================================================
* triangle
*
*  INPUT: range
* RETURN: long 0..range
*
* EFFECT: generates discrete triangle distribution
*=========================================================================*/

static long __inline triangle(long range)

{
	double x1,x2;

	x1 = functions->random(65535) / 65535.0;
	x2 = functions->random(65535) / 65535.0;
	x1 = (x1+x2) * 0.5;
	return( (long)(x1 * range + 0.5) );
} 

/*==========================================================================
* rndrnd
*
*  INPUT: range
* RETURN: long 0..range
*
* EFFECT: generates rnd-rnd distribution over 0 to range
*=========================================================================*/

static long __inline rndrnd(long range)

{
	long num;
	
	num = (long)(
		  (((functions->random(functions->random(65535)) / 65535.0) *
          (functions->random(functions->random(65535)) / 65535.0)))
			 * range + 0.5);
	return(num);
}

/*==========================================================================
* poisson
*
*  INPUT: range
* RETURN: long 0..range
*
* EFFECT: generates Poisson distribution. spread is the mean.
*=========================================================================*/

static long __inline poisson(long range, double spread)

{
	long num=0;
	double u;
	double t;

	u = functions->random(65535) / 65535.0;
	t = exp(-spread);
	while (u > t) {
		num++;
		u *= (functions->random(65535) / 65535.0);
	}
	return( (num <= range) ? num : (long)(range/65535.0 * num) );
}

/*==========================================================================
* linear
*
*  INPUT: range
* RETURN: long  0..range
*
* EFFECT: generates discrete linear distribution
*=========================================================================*/

static long __inline linear(long range)

{
	long x1,x2;

	x1 = functions->random(range);
	x2 = functions->random(range);
	return( (x1 < x2) ? x1 : x2 );
}


/*==========================================================================
* inverse_linear
*
*  INPUT: range
* RETURN: long  0..range
*
* EFFECT: generates discrete inverse linear distribution
*=========================================================================*/

static long __inline inverse_linear(long range)

{
	long x1,x2;

	x1 = functions->random(range);
	x2 = functions->random(range);
	return( (x1 > x2) ? x1 : x2 );
}

/*==========================================================================
* beta
*
*  INPUT: range, probabilities for p0 and p1
* RETURN: long 0..range
*
* EFFECT: generates scaled Beta distribution
*=========================================================================*/

static long __inline beta(long range, double prob0, double prob1)

{
	double t1, t2;
	
	prob0 = 1.0/prob0;
	prob1 = 1.0/prob1;
	do {
		do {
			t1 = fpow(functions->random(65535) / 65535.0, prob0);
		} while (t1==0.0);
		do {
			t2 = fpow(functions->random(65535) / 65535.0, prob1);
		} while (t2==0.0);
	} while ( t1+t2 > 1.0 );
	
	return( (long)(range * (t1/(t1+t2)) + 0.5) );
}

/*==========================================================================
* gauss
*
*  INPUT: range, standard deviation, mean
* RETURN: long
*
* EFFECT: generates bounded Gaussian distribution (Dodge p273; Winsor p190)
*=========================================================================*/

// number of random numbers to grab to approximate
#define GAUSS_COUNT 12

static long __inline gauss(long range, double stdev)

{
	double sum = 0.0;
	long r;
//	double scale = 1.0; //1.0/sqrt(GAUSS_COUNT/12.0);
	UBYTE i;

	for ( i=0 ; i <= GAUSS_COUNT ; i++) {
		do {
			r = functions->random(65535);
		} while ((r==0) || (r==65535));
		sum += r/65535.0;
	}
	r = (long)(stdev * /*scale * */ (sum - (GAUSS_COUNT>>1)) + (range / 2.0));
/* cheat */
	if (r < 0) r *= -1;
	return(r);

//	return((long)(stdev * /*scale * */ (sum - (GAUSS_COUNT>>1)) + (range / 2.0)) );
}

/*==========================================================================
* gamma
*
*  INPUT: range, density
* RETURN: long
*
* EFFECT: generates bounded gamma distribution (Dodge p273-4 & p278; Winsor p188)
*=========================================================================*/

static long __inline gamma(long range, double spread)

{
	double sum = 1.0;
	UBYTE i;
//long value;
	
	for ( i=0 ; i < (UBYTE)spread ; i++ ) {
		sum *= functions->random(65535)/65535.0;
	}
/*
value = (long) ((1.0 - (1.0 / (-log(sum)+1.0))) * range);
dprintf("gamma() range=%ld sum=%f -log(sum)+1=%f value=%ld\n",
         range, sum, -log(sum)+1.0, value);
return (value);
*/
	return( (long) ((1.0 - (1.0 / (-log(sum)+1.0))) * range) );
}

static long RandWalk_last = 0; //randomwalk return

/*==========================================================================
* randomwalk
*
*  INPUT: range
* RETURN: long
*
* EFFECT: does a bounded random walk
*=========================================================================*/

static long __inline randwalk(long range)

{
	if (!RandWalk_last) RandWalk_last = range >>1;
	RandWalk_last += ((functions->random(65535)/65535.0) < 0.5) ? -1 : 1;
	if (RandWalk_last > range) RandWalk_last = range-1;
	else if (RandWalk_last < 0) RandWalk_last = 1;
	return(RandWalk_last);
}

/***************************************/
static void __regargs show(long x, long range)
{
	char text[16];

	sprintf(text,"x=%5ld r=%5ld",x,range);
	Forbid();
	SetRPort(RandomPoop.accessory.window->RPort, NUM_X, NUM_Y, 3 ,0, JAM2);
	Text(RandomPoop.accessory.window->RPort,text,15);
	Permit();
}

/*==========================================================================
* myrandom
*
*  INPUT: long (but really a UWORD) maximum value
* RETURN: long (but really a UWORD)
*
* EFFECT: intercepts calls to functions->random, and calls the selected
*         random number generator or distribution.
*=========================================================================*/

static long __far __stdargs __saveds myrandom(long range)

{
	long x;
	static UBYTE dejavu = 0; /* set if calling from a distribution */

	if ( !RandomPoop.distflags || dejavu ) {
		switch (RandomPoop.baseflags) {
			case BF_FASTRAND :
				x = FastRand(RandomPoop.seed) % (range+1);
				break;
			case BF_RANGERAND :
				x = RangeRand(range);
				break;
			case BF_LRAND :
				x = lrand48() % (range+1);
				break;
			default:
				x = RandomAddress(range);
				break;
		}
	}
	else {
		dejavu = 1;
		switch (RandomPoop.distflags) {
			case DF_LINEAR :
				x = linear(range);
				break;
			case DF_INVLINEAR :
				x = inverse_linear(range);
				break;
			case DF_TRIANGLE :
				x = triangle(range);
				break;
			case DF_RANDRAND :
				x = rndrnd(range);
				break;
			case DF_CAUCHY :
				x = cauchy(range,RandomPoop.parm1/PARM_MULT);
				break;
/***
			case DF_WEIBULL :
				if (RandomPoop.parm1 < WEIBULL_PARM_MIN)
					RandomPoop.parm1 = WEIBULL_PARM_MIN;
				if (RandomPoop.parm2 < WEIBULL_PARM_MIN)
					RandomPoop.parm2 = WEIBULL_PARM_MIN;
				x = weibull(range,RandomPoop.parm1/PARM_MULT,RandomPoop.parm2/PARM_MULT);
				break;
***/
			case DF_BETA :
				x = beta(range,RandomPoop.parm1/PARM_MULT,RandomPoop.parm2/PARM_MULT);
				break;
			case DF_POISSON :
				x = poisson(range,RandomPoop.parm1/PARM_MULT);
				break;
			case DF_GAUSS :
				x = gauss(range,RandomPoop.parm1/PARM_MULT);
				break;
			case DF_GAMMA :
				x = gamma(range,RandomPoop.parm1/PARM_MULT);
				break;
			case DF_EXPONENT :
				x = exponential(range,RandomPoop.parm1/PARM_MULT);
				break;
			case DF_RANDWALK :
				x = randwalk(range);
				break;

		}
		dejavu = 0;
	}
	if ( (RandomPoop.baseflags & BF_SHOW) && (dejavu == 0) && awin ) show(x,range);
	return(x);
}

/*==========================================================================
* reseed
*
*  INPUT: none
* RETURN: none
*
* EFFECT: seeds the generator
*=========================================================================*/

static void __regargs reseed(void)

{
	if (RandomPoop.baseflags & BF_LRAND) {
		srand48(RandomPoop.seed);
	}
	else if (RandomPoop.baseflags & BF_RANGERAND) {
		RangeSeed = RandomPoop.seed;
	}
}

/*==========================================================================
* resetenvironment
*
*  INPUT: none
* RETURN: none
*
* EFFECT: undoes setenvironment
*=========================================================================*/

static void resetenvironment(void)

{
	if (RandomAddress) {
//#pragma msg 147 ignore push
		functions->random = RandomAddress;
//#pragma msg 147 pop
		RandomAddress = NULL;
	}
	if (OldRangeSeed) {
		RangeSeed = OldRangeSeed;
		OldRangeSeed = 0;
	}
}

/*==========================================================================
* setenvironment
*
*  INPUT: none
* RETURN: none
*
* EFFECT: sets up to intercept calls to functions->random
*=========================================================================*/

static void setenvironment(void)

{
	if (!RandomAddress) {
		RandomAddress = /*(APTR)*/functions->random;
		functions->random = myrandom;
	}
	if (!OldRangeSeed) OldRangeSeed = RangeSeed;
	Gadget10SInfo.LongInt = RandomPoop.seed;
	sprintf(Gadget10SIBuff,"%5.5ld",RandomPoop.seed);
	reseed();
}

/*==========================================================================
* CloseWindowSafely
*
*  INPUT: pointer to window
* RETURN: none
*
* EFFECT: safely replies to outstanding messages (compliments mark & dave)
*=========================================================================*/

static void __inline CloseWindowSafely(struct Window *w)

{
	struct IntuiMessage *msg, *succ;

	Forbid();
	msg = (struct IntuiMessage *)w->UserPort->mp_MsgList.lh_Head;
	while(msg->ExecMessage.mn_Node.ln_Succ != NULL) {
		succ = (struct IntuiMessage *)msg->ExecMessage.mn_Node.ln_Succ;
		if (msg->IDCMPWindow == w) {
			Remove((struct Node *)msg);
			ReplyMsg((struct Message *)msg);
		}
		msg = succ;
	}
	w->UserPort = NULL;
	ModifyIDCMP(w,0);
	Permit();
	functions->FlashyCloseWindow(w);
}

/* gadget id offsets for up and down clickers */
#define GU 100
#define GD 200

#define nw NewWindowStructure1

/*==========================================================================
* closewindow
*
*  INPUT: 
* RETURN: 
*
* EFFECT: 
*=========================================================================*/

static long __stdargs __saveds closewindow(void)

{
	UBYTE i;

//dprintf("closewindow()\n");
	if (awin) {
		ClearMenuStrip(awin);
		for ( i=0 ; i < GCOUNT+1 ; i++ ) {
			functions->EmbossOff(awin,RANGERAND+i); // bool+seed string
		}
		functions->FatEmbossedPropOff(awin,GENSEED,GENSEED+GD,GENSEED+GU);
		functions->FatEmbossedPropOff(awin,RANDPARM,RANDPARM+GD,RANDPARM+GU);
		functions->FatEmbossedPropOff(awin,RANDPARM2,RANDPARM2+GD,RANDPARM2+GU);
		RandomPoop.accessory.left = awin->LeftEdge;
		RandomPoop.accessory.top = awin->TopEdge;
		CloseWindowSafely(awin);
		awin = NULL;
		RandomPoop.baseflags &= ~BF_WOPEN;
	}
	return(1);
}

#define REFRESH_GENERATORS 1
#define REFRESH_DISTRIBUTIONS 2
#define REFRESH_POTS 0xF0

/*==========================================================================
* DrawGadgets
*
*  INPUT: bits for which bunch to draw
* RETURN: none
*
* EFFECT: 
*=========================================================================*/

static void __regargs DrawGadgets(UBYTE refresh)

{
	if (refresh & REFRESH_GENERATORS) {
		functions->SelectEmbossed(awin,RANGERAND,
										  RandomPoop.baseflags & BF_RANGERAND);
		functions->SelectEmbossed(awin,FASTRAND,
			                       RandomPoop.baseflags & BF_FASTRAND);
		functions->SelectEmbossed(awin,LRAND,
		                          RandomPoop.baseflags & BF_LRAND);
		EnableFatProp(awin,GENSEED,GENSEED+GD,GENSEED+GU,
		                          RandomPoop.baseflags & (BF_RANGERAND|BF_LRAND));
		functions->EnableEmbossed(awin,SEED_STRING,
		                          RandomPoop.baseflags & (BF_RANGERAND|BF_LRAND));
		functions->EnableEmbossed(awin,RESEED,
		                          RandomPoop.baseflags & (BF_RANGERAND|BF_LRAND));
		if (RandomPoop.baseflags & (BF_RANGERAND|BF_LRAND)) {
			functions->ModifyEmbossedProp(awin,GENSEED,RandomPoop.seed,0,0,0,0,0);
			Gadget10SInfo.LongInt = RandomPoop.seed;
			sprintf(Gadget10SIBuff,"%5.5ld",RandomPoop.seed);
			Gadget10SInfo.DispPos = 0;
			Gadget10SInfo.BufferPos = 0;
		}
		functions->DrawEmbossedProp(awin,GENSEED);
		functions->DrawEmbossed(awin,SEED_STRING);
		functions->DrawEmbossed(awin,RESEED);
	}
	if (refresh & REFRESH_DISTRIBUTIONS) {
		functions->SelectEmbossed(awin,LINEAR,
		                          RandomPoop.distflags & DF_LINEAR);
		functions->SelectEmbossed(awin,INVLINEAR,
		                          RandomPoop.distflags & DF_INVLINEAR);
		functions->SelectEmbossed(awin,TRIANGLE,
		                          RandomPoop.distflags & DF_TRIANGLE);
		functions->SelectEmbossed(awin,RANDRAND,
		                          RandomPoop.distflags & DF_RANDRAND);
		functions->SelectEmbossed(awin,POISSON,
		                          RandomPoop.distflags & DF_POISSON);
/*
		functions->SelectEmbossed(awin,WEIBULL,
		                          RandomPoop.distflags & DF_WEIBULL);
*/
		functions->SelectEmbossed(awin,CAUCHY,
		                          RandomPoop.distflags & DF_CAUCHY);
		functions->SelectEmbossed(awin,BETA,
		                          RandomPoop.distflags & DF_BETA);
		functions->SelectEmbossed(awin,GAUSS,
		                          RandomPoop.distflags & DF_GAUSS);
		functions->SelectEmbossed(awin,GAMMA,
		                          RandomPoop.distflags & DF_GAMMA);
		functions->SelectEmbossed(awin,EXPONENTIAL,
		                          RandomPoop.distflags & DF_EXPONENT);
		functions->SelectEmbossed(awin,RANDWALK,
		                          RandomPoop.distflags & DF_RANDWALK);
#pragma msg 104 ignore push
		if (RandomPoop.distflags & 
		    (DF_POISSON | DF_GAMMA | DF_EXPONENT | DF_CAUCHY)) {
			SetGadgetText(awin,RANDPARM,SpreadTxt);
		}
/*
		else if (RandomPoop.distflags & DF_WEIBULL) {
			SetGadgetText(awin,RANDPARM,SpreadTxt);
			SetGadgetText(awin,RANDPARM2,ShapeTxt);
		}
*/
		else if (RandomPoop.distflags & DF_BETA) {
			SetGadgetText(awin,RANDPARM,Prob0Txt);
			SetGadgetText(awin,RANDPARM2,Prob1Txt);
		}
		else if (RandomPoop.distflags & DF_GAUSS) {
			SetGadgetText(awin,RANDPARM,StdevTxt);
		}
#pragma msg 104 ignore pop

		EnableFatProp(awin,RANDPARM,RANDPARM+GD,RANDPARM+GU,
			RandomPoop.distflags & 
			(DF_BETA|DF_POISSON|DF_WEIBULL|DF_GAUSS|DF_GAMMA|DF_EXPONENT|DF_CAUCHY));
		EnableFatProp(awin,RANDPARM2,RANDPARM2+GD,RANDPARM2+GU,
		              RandomPoop.distflags & (DF_BETA | DF_WEIBULL));
/*
		if (RandomPoop.parm1 <= 0) RandomPoop.parm1 = 1;
		if (RandomPoop.parm2 <= 0) RandomPoop.parm2 = 1;
*/
		functions->ModifyEmbossedProp(awin,RANDPARM,RandomPoop.parm1,0,0,0,0,0);
		functions->ModifyEmbossedProp(awin,RANDPARM2,RandomPoop.parm2,0,0,0,0,0);
		functions->DrawEmbossedProp(awin,RANDPARM);
		functions->DrawEmbossedProp(awin,RANDPARM2);
	}
}

/*==========================================================================
* seedhilo
*
*  INPUT: pointers to window and gadget, gadget value
* RETURN: gadget value
*
* EFFECT: displays pot value in a string gadget
*=========================================================================*/

static long __stdargs __saveds seedhilo(struct Window *w,struct Gadget *g,long h)

{
	Gadget10SInfo.LongInt = h;
	sprintf(Gadget10SIBuff,"%5.5ld",h);
	Gadget10SInfo.DispPos = 0;
	Gadget10SInfo.BufferPos = 0;
	functions->DrawEmbossed(awin,SEED_STRING);
	return(h);
}

/*==========================================================================
* hilo10
*
*  INPUT: pointers to window and gadget, gadget value
* RETURN: gadget value
*
* EFFECT: display a pot value divided by multiplier as a decimal quantity
*=========================================================================*/

static long __stdargs __saveds hilo10(struct Window *w,struct Gadget *g,long h)

{
	char text[7];

	if (h == 0) h = 1;
	SetRPort(w->RPort, g->LeftEdge+g->Width+XOffset-3, g->TopEdge+YOffset,
	         (g->Flags & GADGDISABLED) ? HILO_DPEN : HILO_APEN,
				HILO_BPEN, HILO_DRAWMODE);
	sprintf(text,"%6.2f",(double)(h/PARM_MULT));
	Text(w->RPort,text,6);
	return(h);
}

/*==========================================================================
* openwindow
*=========================================================================*/

static long __stdargs __saveds openwindow(void)

{
	UBYTE i;
	if (!awin) {
		Gadget10SInfo.LongInt = RandomPoop.seed;
		sprintf(Gadget10SIBuff,"%5.5ld",RandomPoop.seed);
		Gadget10SInfo.DispPos = 0;
		Gadget10SInfo.BufferPos = 0;
		nw.Screen = functions->screen;
		if (RandomPoop.accessory.left + nw.Width > functions->screen->Width) {
			nw.LeftEdge = functions->screen->Width - nw.Width >> 1;
		}
		else nw.LeftEdge = RandomPoop.accessory.left;
		if (RandomPoop.accessory.top + nw.Height > functions->screen->Height) {
			nw.TopEdge = functions->screen->Height - nw.Height >> 1;
		}
		else nw.TopEdge = RandomPoop.accessory.top;
//dprintf("left=%ld top=%ld\n",RandomPoop.accessory.left,RandomPoop.accessory.top);
		nw.Flags &= ~0xF;
		nw.IDCMPFlags = 0;
		nw.DetailPen = nw.BlockPen = 0;
		awin = functions->FlashyOpenWindow(&nw);
		if (awin) {
#pragma msg 104 ignore push
			functions->EmbossWindowOn(awin,
			                          WINDOWCLOSE|WINDOWDEPTH|WINDOWDRAG,
			                          WTITLE,(short)-1,(short)-1,0,0);
#pragma msg 104 ignore pop
			awin->UserPort = functions->window->UserPort;
			ModifyIDCMP(awin,functions->window->IDCMPFlags);
			DrawBevelBox(awin->RPort,GEN_X,GEN_Y,GEN_X2,GEN_Y2,-1,-1,1);
			DrawBevelBox(awin->RPort,DIST_X,DIST_Y,DIST_X2,DIST_Y2,-1,-1,1);
			PrintIText(awin->RPort,&IntuiTextList1,0,0);
			for ( i=0 ; i < GCOUNT ; i++) {
				functions->EmbossOn(awin,RANGERAND+i,1);
			}
			functions->EmbossOn(awin,SEED_STRING,3);
			functions->FatEmbossedPropOn(awin,GENSEED,GENSEED+GD,
			                             GENSEED+GU,seedhilo,65535,1);
			functions->FatEmbossedPropOn(awin,RANDPARM,RANDPARM+GD,
			                             RANDPARM+GU,hilo10,MAXRANDPARM+1,1);
			functions->FatEmbossedPropOn(awin,RANDPARM2,RANDPARM2+GD,
			                             RANDPARM2+GU,hilo10,MAXRANDPARM+1,1);
			SetWindowTitles(awin,(UBYTE *)-1,Menu1.MenuName);
			SetMenuStrip(awin,&MenuList1);
			DrawGadgets(255);
			RandomPoop.baseflags |= BF_WOPEN;
		}
//else dprintf("damned window thinks it's open\n");
	}
	return((long)awin);
}

/*==========================================================================
* editwindow
*
*  INPUT: pointer to IntuiMessage
* RETURN: 1
*
* EFFECT: handles ui interaction
*=========================================================================*/

static long __stdargs __saveds editwindow(struct IntuiMessage *message)

{
	struct Gadget *gadget = (struct Gadget *)message->IAddress;
	long code = message->Code;
	long class = message->Class;
	UBYTE refresh = 0;

	ReplyMsg((struct Message *)message);
	class = functions->SystemGadgets(awin,class,gadget,code);

	if (class == CLOSEWINDOW) {
//dprintf("got close\n");
		closewindow();
	}
	if (class == MENUPICK) { // secret menu to show inputs & outputs
		if (ITEMNUM(code) == 0) RandomPoop.baseflags ^= BF_SHOW;
	}
	else if (class == GADGETUP) {
		switch (gadget->GadgetID) {
			case RESEED :
				reseed();
				break;
/*
			case DISPLAY :
				RandomPoop.baseflags ^= BF_SHOW;
				functions->SelectEmbossed(awin,DISPLAY,RandomPoop.baseflags & BF_SHOW);
				break;
*/
			/*** random number generators ***/
			case RANGERAND:
				RandomPoop.baseflags ^= BF_RANGERAND;
				RandomPoop.baseflags &= (BF_RANGERAND | BF_SHOW);
				refresh = REFRESH_GENERATORS;
				break;
			case FASTRAND:
				RandomPoop.baseflags ^= BF_FASTRAND;
				RandomPoop.baseflags &= (BF_FASTRAND | BF_SHOW);
				refresh = REFRESH_GENERATORS;
				break;
			case LRAND:
				RandomPoop.baseflags ^= BF_LRAND;
				RandomPoop.baseflags &= (BF_LRAND | BF_SHOW);
				refresh = REFRESH_GENERATORS;
				break;
			/*** random distributions ***/
			case BETA:
				RandomPoop.distflags ^= DF_BETA;
				RandomPoop.distflags &= DF_BETA;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case POISSON:
				RandomPoop.distflags ^= DF_POISSON;
				RandomPoop.distflags &= DF_POISSON;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case LINEAR:
				RandomPoop.distflags ^= DF_LINEAR;
				RandomPoop.distflags &= DF_LINEAR;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case INVLINEAR:
				RandomPoop.distflags ^= DF_INVLINEAR;
				RandomPoop.distflags &= DF_INVLINEAR;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case TRIANGLE:
				RandomPoop.distflags ^= DF_TRIANGLE;
				RandomPoop.distflags &= DF_TRIANGLE;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
/*
			case WEIBULL:
				RandomPoop.distflags ^= DF_WEIBULL;
				RandomPoop.distflags &= DF_WEIBULL;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
*/
			case CAUCHY:
				RandomPoop.distflags ^= DF_CAUCHY;
				RandomPoop.distflags &= DF_CAUCHY;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case GAMMA:
				RandomPoop.distflags ^= DF_GAMMA;
				RandomPoop.distflags &= DF_GAMMA;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case GAUSS:
				RandomPoop.distflags ^= DF_GAUSS;
				RandomPoop.distflags &= DF_GAUSS;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDRAND:
				RandomPoop.distflags ^= DF_RANDRAND;
				RandomPoop.distflags &= DF_RANDRAND;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case EXPONENTIAL:
				RandomPoop.distflags ^= DF_EXPONENT;
				RandomPoop.distflags &= DF_EXPONENT;
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDWALK:
				RandomPoop.distflags ^= DF_RANDWALK;
				RandomPoop.distflags &= DF_RANDWALK;
				if (RandomPoop.distflags & DF_RANDWALK) RandWalk_last = 0;
				refresh = REFRESH_DISTRIBUTIONS;
				break;

			case SEED_STRING :
				if ((Gadget10SInfo.LongInt < 65536) && (Gadget10SInfo.LongInt >= 0)) {
					RandomPoop.seed = Gadget10SInfo.LongInt;
					reseed();
				}
				else { // bad entry
					strcpy((char *)Gadget10SIBuff,(char *)UndoBuff);
					Gadget10SInfo.LongInt = RandomPoop.seed;
					Gadget10SInfo.DispPos = 0;
					Gadget10SInfo.BufferPos = 0;
					functions->DrawEmbossed(awin,SEED_STRING);
					DisplayBeep(functions->screen);
					ActivateGadget(gadget,awin,NULL);
				}
				refresh = REFRESH_GENERATORS;
				break;
		}
	}
	else if (class == GADGETDOWN) {
		switch (gadget->GadgetID) {
			case GENSEED :
				RandomPoop.seed = functions->DragEmbossedProp(awin,GENSEED);
				reseed();
				refresh = REFRESH_GENERATORS;
				break;
			case GENSEED+GD :
				RandomPoop.seed = functions->ShiftEmbossedProp(awin,GENSEED,-1,0);
				reseed();
				refresh = REFRESH_GENERATORS;
				break;
			case GENSEED+GU :
				RandomPoop.seed = functions->ShiftEmbossedProp(awin,GENSEED,1,0);
				reseed();
				refresh = REFRESH_GENERATORS;
				break;

			case RANDPARM :
				RandomPoop.parm1 = functions->DragEmbossedProp(awin,RANDPARM);
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDPARM+GD :
				RandomPoop.parm1 = functions->ShiftEmbossedProp(awin,RANDPARM,-1,0);
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDPARM+GU :
				RandomPoop.parm1 = functions->ShiftEmbossedProp(awin,RANDPARM,1,0);
				refresh = REFRESH_DISTRIBUTIONS;
				break;

			case RANDPARM2 :
				RandomPoop.parm2 = functions->DragEmbossedProp(awin,RANDPARM2);
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDPARM2+GD :
				RandomPoop.parm2 = functions->ShiftEmbossedProp(awin,RANDPARM2,-1,0);
				refresh = REFRESH_DISTRIBUTIONS;
				break;
			case RANDPARM2+GU :
				RandomPoop.parm2 = functions->ShiftEmbossedProp(awin,RANDPARM2,1,0);
				refresh = REFRESH_DISTRIBUTIONS;
				break;

//			default: break;
		}
	}
	/* avoid underflow with a small parms for weibull distribution */
/*
	if (RandomPoop.distflags & DF_WEIBULL) {
		if (RandomPoop.parm1 < WEIBULL_PARM_MIN) RandomPoop.parm1 = WEIBULL_PARM_MIN;
		if (RandomPoop.parm2 < WEIBULL_PARM_MIN) RandomPoop.parm2 = WEIBULL_PARM_MIN;
	}
*/
	if (refresh) DrawGadgets(refresh);
	return(1);
}

/*==========================================================================
* sizedata
*
*  INPUT: pointer to Environment
* RETURN: number of bytes required to write this thing
*
* EFFECT: duh
*=========================================================================*/

static long __stdargs __saveds sizedata(struct Environment *env)

{
//dprintf("sizedata() env=%ld size=%ld\n",env,DATA_SIZE);
	return(DATA_SIZE);
}

/*==========================================================================
* savedata
*
*  INPUT: file id, pointer to Environment
* RETURN: 0 if successful; 1 if not
*
* EFFECT: writes accessory data to a .song file
*=========================================================================*/

static long __stdargs __saveds savedata(long file, struct Environment *env)

{
	long size;

	size = RandomPoop.accessory.id;
	if (functions->fastwrite(file,(char *)&size,4) == -1) return(1);
//else dprintf("wrote %ld (id)\n",size);
	if (RandomPoop.baseflags & BF_WOPEN) {
		RandomPoop.accessory.left = awin->LeftEdge;
		RandomPoop.accessory.top = awin->TopEdge;
	}
	size = DATA_SIZE;
//dprintf("save() env=%ld functions=%ld size=%ld\n",env,functions,size);
	if (functions->fastwrite(file,(char *)&size,4) == -1) return(1);
//else dprintf("wrote %ld (size)\n",size);
	if (functions->fastwrite(file,(char *)&(RandomPoop.baseflags),size-4) == -1)
		return(1);
//else dprintf("wrote %ld (flags)\n",RandomPoop.baseflags);
	if (functions->fastwrite(file,((char *)&(RandomPoop.accessory.left)),2) == -1) 
		return(1);
//else dprintf("wrote %ld (left)\n",RandomPoop.accessory.left);
	if (functions->fastwrite(file,((char *)&(RandomPoop.accessory.top)),2) == -1) 
		return(1);
//else dprintf("wrote %ld (top)\n",RandomPoop.accessory.top);
	return(0);
}

/*==========================================================================
* loaddata
*
*  INPUT: file id, pointer to Environment, size of data to read
* RETURN: 1
*
* EFFECT: reads accessory data from .song file
*=========================================================================*/

static long __stdargs __saveds loaddata(long file, struct Environment *env,
                                        long size)
{

//dprintf("load() env=%ld f=%ld\n",env,functions);
//	RandomPoop.baseflags &= ~BF_WOPEN; // in case this one is open
	functions->fastread(file,(char *)&RandomPoop.baseflags,size-4);
	functions->fastread(file,(char *)&RandomPoop.accessory.left,2);
	functions->fastread(file,(char *)&RandomPoop.accessory.top,2);
	setenvironment();
	if (RandomPoop.baseflags & BF_WOPEN) { //if the saved one was open...
		openwindow();
	}
	return(1);
}

/*==========================================================================
* remove
*
*  INPUT: none
* RETURN: none
*
* EFFECT: restores functions->random & closes math libraries
*=========================================================================*/

static long __stdargs __saveds remove_accessory(void)
{
//dprintf("remove()\n");
	Forbid(); //avoid being unloadseg'ed before closing
	resetenvironment();
	if (MathIeeeDoubTransBase) CloseLibrary(MathIeeeDoubTransBase);
	if (MathIeeeDoubBasBase) CloseLibrary(MathIeeeDoubBasBase);
	MathIeeeDoubTransBase = NULL;
	MathIeeeDoubBasBase = NULL;
	WaitTOF();  //timing is everything
	WaitTOF();
	Permit();
	return(1);
}

/*!!!!!
 * APPARENTLY, if there is no install() then load() will NOT be called *
 * BUT clipthing works with no install(), doesn't it???? hmmmmmmm
 !!!!*/
static long __stdargs __saveds installmeoriwontload(struct Environment *e)
{
//	dprintf("install() e=%ld f=%ld\n",e,functions);
	return(1);
}

/*!!!!!
 * ditto for clear() and remove(). THAT'S why the libs weren't closed!
 */
static long __stdargs __saveds clearornoremove(struct Environment *e)
{
	return(1);
}

/**************************************************************************/
struct Accessory * __stdargs __saveds inittoolmaster(void)
{
	struct EasyStruct es = {
		sizeof(struct EasyStruct),
		0,
		"Random Numbers Accessory",
		"Requires mathieeedoubbas.library and\nmathieeedoubtrans.library",
		"Whoops",
	};
	if (MathIeeeDoubBasBase = OpenLibrary("mathieeedoubbas.library",0)) {
		if (MathIeeeDoubTransBase = OpenLibrary("mathieeedoubtrans.library",0)) {
			memset((char *)&RandomPoop,0,sizeof(struct RandomPoop));
			RandomPoop.accessory.id = RNMB_ID;
			RandomPoop.accessory.left = (functions->screen->Width - nw.Width) >> 1;
			RandomPoop.accessory.top = (functions->screen->Height - nw.Height) >> 1;
			RandomPoop.accessory.image = &IconUp;
			RandomPoop.accessory.onimage = &IconDown;
			RandomPoop.accessory.open = openwindow;
			RandomPoop.accessory.close = closewindow;
			RandomPoop.accessory.edit = editwindow;
			RandomPoop.accessory.remove = remove_accessory;
			RandomPoop.accessory.load = loaddata;
			RandomPoop.accessory.save = savedata;
			RandomPoop.accessory.install = installmeoriwontload;
			RandomPoop.accessory.clear = clearornoremove;
			strcpy(RandomPoop.accessory.name,ACC_NAME);
			setenvironment();
		}
	}
	if (MathIeeeDoubBasBase && MathIeeeDoubTransBase) {
		return((struct Accessory *)&RandomPoop);
	}
	else {
		EasyRequestArgs(NULL,&es,NULL,NULL);
		return(NULL);
	}
}
