/***
*		RandNumbw.h -- ui for RandomNumbers.paccess
*		 1995,1997 Another Option   All rights reserved.
***/

/*
=============================================================================
|   DATE   | WHAT
=============================================================================
  8 Sep 95 | created
 11 Sep 95 | added more distributions
 11 Jan 97 | added exp & randwalk; changed to smaller box for generators;
           | moved distributions up
 14 Sep 97 | removed display gadget & moved stuff accordingly; added secret
           | menuitem to display outputs for debugging & amusement.
*/

/* random generators */
#define RANGERAND 1
#define FASTRAND  2
#define LRAND     3

/* random distributions */
#define BETA         4
#define POISSON      5
#define LINEAR       6
#define TRIANGLE     7
//#define WEIBULL      8
#define CAUCHY       8
#define RANDRAND     9
#define INVLINEAR   10
#define GAUSS       11
#define GAMMA       12
#define EXPONENTIAL 13
#define RANDWALK    14
#define RESEED      15

#define LAST_BOOL_GADGET RESEED

#define RANDPARM    30
#define RANDPARM2   31
#define GENSEED     32
#define SEED_STRING 33

/* box coordinates */
#define GEN_X    8
#define GEN_Y   18
#define GEN_X2 426
#define GEN_Y2  55

/* a constant for adjusting the location of distribution gadgets etc. as i seem
   to keep moving stuff around
*/
#define TWIDDLE_OFFSET_Y ( -9 )

#define DIST_X    8
#define DIST_Y   73+TWIDDLE_OFFSET_Y
#define DIST_X2 426
#define DIST_Y2 146+TWIDDLE_OFFSET_Y

/* text for distribution pots */
static char const SpreadTxt[]  = " Spread:"; // for RANDPARM
static char const Prob0Txt[]   = "  Prob0:"; // for RANDPARM
static char const StdevTxt[]   = " StdDev:"; // for RANDPARM

static char const ShapeTxt[]   = "Shape:";  // for RANDPARM2
static char const Prob1Txt[]   = "Prob1:";  // for RANDPARM2

static struct PropInfo Gadget13SInfo = {
	AUTOKNOB+FREEHORIZ,
	0,0,
	5957,-1,
};

static struct Image Image1 = {
	0,0,
	8,3,
	0,
	NULL,
	0x0000,0x0000,
	NULL
};

static struct IntuiText IText1 = {
	2,0,JAM2,
	-67,0,
	NULL,
	(UBYTE *)SpreadTxt,
	NULL
};

static struct Gadget Gadget13 = {
	NULL,
	80,134+TWIDDLE_OFFSET_Y,
	92,7,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+GADGIMMEDIATE,
	PROPGADGET,
	(APTR)&Image1,
	NULL,
	&IText1,
	NULL,
	(APTR)&Gadget13SInfo,
	RANDPARM,
	NULL
};

static struct PropInfo Gadget12SInfo = {
	AUTOKNOB+FREEHORIZ,
	0,0,
	5957,-1,
};

static struct Image Image2 = {
	0,0,
	8,3,
	0,
	NULL,
	0x0000,0x0000,
	NULL
};

static struct IntuiText IText2 = {
	2,0,JAM2,
	-51,0,
	NULL,
	(UBYTE *)ShapeTxt,
	NULL
};

static struct Gadget Gadget12 = {
	&Gadget13,
	280,134+TWIDDLE_OFFSET_Y,
	92,7,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+GADGIMMEDIATE,
	PROPGADGET,
	(APTR)&Image2,
	NULL,
	&IText2,
	NULL,
	(APTR)&Gadget12SInfo,
	RANDPARM2,
	NULL
};

static struct PropInfo Gadget11SInfo = {
	AUTOKNOB+FREEHORIZ,
	0,0,
	10,-1, //5957,-1,
};

static struct Image Image3 = {
	43,0,
	20,3,
	0,
	NULL,
	0x0000,0x0000,
	NULL
};

static struct IntuiText IText3 = {
	2,0,JAM1,
	-43,0,
	NULL,
	"Seed:",
	NULL
};

static struct Gadget Gadget11 = {
	&Gadget12,
	56,41,
	228,7,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+GADGIMMEDIATE,
	PROPGADGET,
	(APTR)&Image3,
	NULL,
	&IText3,
	NULL,
	(APTR)&Gadget11SInfo,
	GENSEED,
	NULL
};

static UBYTE UndoBuff[6];
static UBYTE Gadget10SIBuff[6];
static struct StringInfo Gadget10SInfo = {
	Gadget10SIBuff,
	UndoBuff,
	0,
	6,
	0,
	0,0,0,0,0,
	0,
	0,
	NULL
};

static struct Gadget Gadget10 = {
	&Gadget11,
	288,40,
	48,9,
	NULL,
	RELVERIFY+STRINGRIGHT+LONGINT,
	STRGADGET,
	NULL,
	NULL,
	NULL,
	NULL,
	(APTR)&Gadget10SInfo,
	SEED_STRING,
	NULL
};

/*
static struct IntuiText IText479 = {
	4,0,JAM1,
	10,1,
	NULL,
	"Display Output",
	NULL
};

static struct Gadget Gadget1979 = {
	&Gadget10,
	155,60,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText479,
	NULL,
	NULL,
	DISPLAY,
	NULL
};
*/

static struct IntuiText IText91 = {
	4,0,JAM1,
	16,1,
	NULL,
	"Reseed",
	NULL
};

static struct Gadget Gadget920 = {
	&Gadget10, //&Gadget1979,
	342,40,
	80,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY,
	BOOLGADGET,
	NULL,
	NULL,
	&IText91,
	NULL,
	NULL,
	RESEED,
	NULL
};

static struct IntuiText IText569 = {
	4,0,JAM1,
	23,1,
	NULL,
	"Random Walk",
	NULL
};

static struct Gadget Gadget1769 = {
	&Gadget920,
	151,116+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText569,
	NULL,
	NULL,
	RANDWALK,
	NULL
};

static struct IntuiText IText669 = {
	4,0,JAM1,
	23,1,
	NULL,
	"Exponential",
	NULL
};

static struct Gadget Gadget1669 = {
	&Gadget1769,
	13,116+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText669,
	NULL,
	NULL,
	EXPONENTIAL,
	NULL
};

static struct IntuiText IText814 = {
	4,0,JAM1,
	47,1,
	NULL,
	"Gamma",
	NULL
};

static struct Gadget Gadget89 = {
	&Gadget1669,
	289,104+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText814,
	NULL,
	NULL,
	GAMMA,
	NULL
};

static struct IntuiText IText815 = {
	4,0,JAM1,
	47,1,
	NULL,
	"Gauss",
	NULL
};

static struct Gadget Gadget88 = {
	&Gadget89,
	151,104+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText815,
	NULL,
	NULL,
	GAUSS,
	NULL
};

static struct IntuiText IText4 = {
	4,0,JAM1,
	51,1,
	NULL,
	"Beta",
	NULL
};

static struct Gadget Gadget9 = {
	&Gadget88,
	13,104+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText4,
	NULL,
	NULL,
	BETA,
	NULL
};

static struct IntuiText IText5 = {
	4,0,JAM1,
	27,1,
	NULL,
	"Cauchy (+)",
	NULL
};

static struct Gadget Gadget8 = {
	&Gadget9,
	289,92+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText5,
	NULL,
	NULL,
	CAUCHY,
	NULL
};

static struct IntuiText IText6 = {
	4,0,JAM1,
	39,1,
	NULL,
	"Poisson",
	NULL
};

static struct Gadget Gadget7 = {
	&Gadget8,
	151,92+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText6,
	NULL,
	NULL,
	POISSON,
	NULL
};

static struct IntuiText IText7 = {
	4,0,JAM1,
	31,1,
	NULL,
	"Rand-Rand",
	NULL
};

static struct Gadget Gadget6 = {
	&Gadget7,
	13,92+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText7,
	NULL,
	NULL,
	RANDRAND,
	NULL
};

static struct IntuiText IText8 = {
	4,0,JAM1,
	35,1,
	NULL,
	"Triangle",
	NULL
};

static struct Gadget Gadget5 = {
	&Gadget6,
	289,80+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText8,
	NULL,
	NULL,
	TRIANGLE,
	NULL
};

static struct IntuiText IText821 = {
	4,0,JAM1,
	11,1,
	NULL,
	"Inverse Linear",
	NULL
};

static struct Gadget Gadget82 = {
	&Gadget5,
	151,80+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText821,
	NULL,
	NULL,
	INVLINEAR,
	NULL
};
static struct IntuiText IText9 = {
	4,0,JAM1,
	39,1,
	NULL,
	"Linear",
	NULL
};

static struct Gadget Gadget4 = {
	&Gadget82,
	13,80+TWIDDLE_OFFSET_Y,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText9,
	NULL,
	NULL,
	LINEAR,
	NULL
};

static struct IntuiText IText10 = {
	4,0,JAM1,
	15,1,
	NULL,
	"SAS/C lrand48",
	NULL
};

static struct Gadget Gadget3 = {
	&Gadget4,
	289,25,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText10,
	NULL,
	NULL,
	LRAND,
	NULL
};

static struct IntuiText IText11 = {
	4,0,JAM1,
	11,1,
	NULL,
	"Amiga FastRand",
	NULL
};

static struct Gadget Gadget2 = {
	&Gadget3,
	151,25,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText11,
	NULL,
	NULL,
	FASTRAND,
	NULL
};

static struct IntuiText IText12 = {
	4,0,JAM1,
	7,1,
	NULL,
	"Amiga RangeRand",
	NULL
};

static struct Gadget Gadget1 = {
	&Gadget2,
	13,25,
	133,9,
	GADGHBOX+GADGHIMAGE,
	RELVERIFY+TOGGLESELECT,
	BOOLGADGET,
	NULL,
	NULL,
	&IText12,
	NULL,
	NULL,
	RANGERAND,
	NULL
};

#define GadgetList1 Gadget1

static struct MenuItem MenuItem1 = { // secret menu item to display output
	NULL,
	0,0,
	80,0,
	ITEMTEXT+COMMSEQ+ITEMENABLED+HIGHCOMP,
	0,
	NULL,
	NULL,
	'D',
	NULL,
	MENUNULL
};

static struct Menu Menu1 = {
	NULL,
	0,0,
	0,0,
	MENUENABLED,
	"Random Numbers v1.1  1997 Michael Rees",
	&MenuItem1
};

#define MenuList1 Menu1

static struct IntuiText IText15 = {
	1,0,JAM2,
	13,69+TWIDDLE_OFFSET_Y,
	NULL,
	"Distribution",
	NULL
};

static struct IntuiText IText14 = {
	1,0,JAM2,
	13,14,
	NULL,
	"Generator",
	&IText15
};

#define IntuiTextList1 IText14

static struct NewWindow NewWindowStructure1 = {
	123,19,
	435,153+TWIDDLE_OFFSET_Y,
	0,1,
	NULL, //CLOSEWINDOW,
	WINDOWDRAG+WINDOWDEPTH+WINDOWCLOSE+ACTIVATE+NOCAREREFRESH+BORDERLESS,
	&Gadget1,
	NULL,
	NULL,
	NULL,
	NULL,
	5,5,
	-1,-1,
	CUSTOMSCREEN
};

#define WTITLE "Random Numbers"
#define GCOUNT LAST_BOOL_GADGET